package liste;

/**
 * Classe con alcune funzioni su liste - versione ricorsiva
 * 
 * @author Stefano Guerrini
 * @version Marzo 2009
 */
public final class ListeLibRic
{
    /**
     * rovescia una lista (ricorsiva)
     * crea una nuova lista, clona anche le etichette
     * 
     * @param lista     lista da rovesciare
     * @param nuova     lista su cui rovesciare
     * @return          la nuova lista
     */
    public static Nodo revLista(Nodo lista)
    {        
        return revLista(lista, null);
    }

    /**
     * rovescia una lista (ricorsiva)
     * crea una nuova lista, clona anche le etichette
     * 
     * @param lista     lista da rovesciare
     * @param nuova     lista su cui rovesciare
     * @return          la nuova lista
     */
    public static Nodo revLista(Nodo lista, Nodo nuova)
    {        
        if (lista == null)
            return nuova;
        else
            return revLista(lista.next(), new Nodo(lista.label().clona(), nuova));
    }

    /**
     * copia una lista (ricorsiva)
     * crea una nuova lista, clona anche le etichette
     * 
     * @param lista     lista da copiare
     * @return          la nuova lista
     */
    public static Nodo copiaLista(Nodo lista)
    {
        if (lista == null)
            return null;
        else
            return new Nodo(lista.label().clona(), copiaLista(lista.next()));
    }

    /**
     * stampa una lista (ricorsiva)
     * 
     * @param lista     lista da stampare
     */
    public static void stampaLista(Nodo lista)
    {
        if (lista != null)
        {
            System.out.print(lista.label().toString() + " ");
            stampaLista(lista.next());
        }
    }
}